Index: src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,10 +6,19 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/AnalysisAction/PrincipalAxisSystemAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "LinearAlgebra/Matrix.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "element.hpp"
 #include "molecule.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
 
 #include <iostream>
@@ -20,5 +29,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 
 const char AnalysisPrincipalAxisSystemAction::NAME[] = "principal-axis-system";
@@ -31,41 +40,64 @@
 {}
 
+void AnalysisPrincipalAxisSystem() {
+  ActionRegistry::getInstance().getActionByName(AnalysisPrincipalAxisSystemAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* AnalysisPrincipalAxisSystemAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr AnalysisPrincipalAxisSystemAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   molecule *mol = NULL;
+  Matrix InertiaTensor;
 
-  dialog->queryMolecule(NAME, &mol, MapOfActions::getInstance().getDescription(NAME));
+  ValueStorage::getInstance().queryCurrentValue(NAME, mol);
+  DoLog(0) && (Log() << Verbose(0) << "Evaluating prinicipal axis." << endl);
+  for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
+    molecule *mol = iter->second;
+    Vector *CenterOfGravity = mol->DetermineCenterOfGravity();
 
-  if(dialog->display()) {
-    DoLog(0) && (Log() << Verbose(0) << "Evaluating prinicipal axis." << endl);
-    mol->PrincipalAxisSystem(false);
-    delete dialog;
-    return Action::success;
-  } else {
-    delete dialog;
-    return Action::failure;
+    // reset inertia tensor
+    InertiaTensor.zero();
+
+    // sum up inertia tensor
+    for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+      Vector x = (*iter)->getPosition();
+      x -= *CenterOfGravity;
+      const double mass = (*iter)->getType()->mass;
+      InertiaTensor.at(0,0) += mass*(x[1]*x[1] + x[2]*x[2]);
+      InertiaTensor.at(0,1) += mass*(-x[0]*x[1]);
+      InertiaTensor.at(0,2) += mass*(-x[0]*x[2]);
+      InertiaTensor.at(1,0) += mass*(-x[1]*x[0]);
+      InertiaTensor.at(1,1) += mass*(x[0]*x[0] + x[2]*x[2]);
+      InertiaTensor.at(1,2) += mass*(-x[1]*x[2]);
+      InertiaTensor.at(2,0) += mass*(-x[2]*x[0]);
+      InertiaTensor.at(2,1) += mass*(-x[2]*x[1]);
+      InertiaTensor.at(2,2) += mass*(x[0]*x[0] + x[1]*x[1]);
+    }
+    // print InertiaTensor for debugging
+    DoLog(0) && (Log() << Verbose(0) << "The inertia tensor is:" << InertiaTensor << endl);
   }
+  return Action::success;
 }
 
 Action::state_ptr AnalysisPrincipalAxisSystemAction::performUndo(Action::state_ptr _state) {
-//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
-
-  return Action::failure;
-//  string newName = state->mol->getName();
-//  state->mol->setName(state->lastName);
-//
-//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+  return Action::success;
 }
 
 Action::state_ptr AnalysisPrincipalAxisSystemAction::performRedo(Action::state_ptr _state){
-  return Action::failure;
+  return Action::success;
 }
 
 bool AnalysisPrincipalAxisSystemAction::canUndo() {
-  return false;
+  return true;
 }
 
 bool AnalysisPrincipalAxisSystemAction::shouldUndo() {
-  return false;
+  return true;
 }
 
Index: src/Actions/AnalysisAction/PrincipalAxisSystemAction.hpp
===================================================================
--- src/Actions/AnalysisAction/PrincipalAxisSystemAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/AnalysisAction/PrincipalAxisSystemAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,9 @@
 #include "Actions/Action.hpp"
 
+void AnalysisPrincipalAxisSystem();
+
 class AnalysisPrincipalAxisSystemAction : public Action {
+  friend void AnalysisPrincipalAxisSystem();
+
 public:
   AnalysisPrincipalAxisSystemAction();
@@ -20,4 +24,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,164 @@
+/*
+ * SurfaceCorrelationAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Actions/AnalysisAction/SurfaceCorrelationAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "analysis_correlation.hpp"
+#include "boundary.hpp"
+#include "linkedcell.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "element.hpp"
+#include "molecule.hpp"
+#include "periodentafel.hpp"
+#include "tesselation.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+const char AnalysisSurfaceCorrelationAction::NAME[] = "surface-correlation";
+
+AnalysisSurfaceCorrelationAction::AnalysisSurfaceCorrelationAction() :
+  Action(NAME)
+{}
+
+AnalysisSurfaceCorrelationAction::~AnalysisSurfaceCorrelationAction()
+{}
+
+void AnalysisSurfaceCorrelation(std::vector< element *> &elements, molecule *mol, double BinStart, double BinWidth, double BinEnd, std::string &outputname, std::string &binoutputname, bool periodic) {
+  ValueStorage::getInstance().setCurrentValue("elements", elements);
+  ValueStorage::getInstance().setCurrentValue("molecule-by-id", mol);
+  ValueStorage::getInstance().setCurrentValue("bin-start", BinStart);
+  ValueStorage::getInstance().setCurrentValue("bin-width", BinWidth);
+  ValueStorage::getInstance().setCurrentValue("bin-end", BinEnd);
+  ValueStorage::getInstance().setCurrentValue("output-file", outputname);
+  ValueStorage::getInstance().setCurrentValue("bin-output-file", binoutputname);
+  ValueStorage::getInstance().setCurrentValue("periodic", periodic);
+  ActionRegistry::getInstance().getActionByName(AnalysisSurfaceCorrelationAction::NAME)->call(Action::NonInteractive);
+};
+
+
+Dialog* AnalysisSurfaceCorrelationAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryMolecule("molecule-by-id", ValueStorage::getInstance().getDescription("molecule-by-id"));
+  dialog->queryElements("elements", ValueStorage::getInstance().getDescription("elements"));
+  dialog->queryDouble("bin-start", ValueStorage::getInstance().getDescription("bin-start"));
+  dialog->queryDouble("bin-width", ValueStorage::getInstance().getDescription("bin-width"));
+  dialog->queryDouble("bin-end", ValueStorage::getInstance().getDescription("bin-end"));
+  dialog->queryString("output-file", ValueStorage::getInstance().getDescription("output-file"));
+  dialog->queryString("bin-output-file", ValueStorage::getInstance().getDescription("bin-output-file"));
+  dialog->queryBoolean("periodic", ValueStorage::getInstance().getDescription("periodic"));
+
+  return dialog;
+}
+
+Action::state_ptr AnalysisSurfaceCorrelationAction::performCall() {
+  int ranges[3] = {1, 1, 1};
+  double BinEnd = 0.;
+  double BinStart = 0.;
+  double BinWidth = 0.;
+  molecule *Boundary = NULL;
+  string outputname;
+  string binoutputname;
+  bool periodic;
+  ofstream output;
+  ofstream binoutput;
+  std::vector<const element *> elements;
+  string type;
+  Vector Point;
+  BinPairMap *binmap = NULL;
+
+  // obtain information
+  ValueStorage::getInstance().queryCurrentValue("molecule-by-id", Boundary);
+  ValueStorage::getInstance().queryCurrentValue("elements", elements);
+  ValueStorage::getInstance().queryCurrentValue("bin-start", BinStart);
+  ValueStorage::getInstance().queryCurrentValue("bin-width", BinWidth);
+  ValueStorage::getInstance().queryCurrentValue("bin-end", BinEnd);
+  ValueStorage::getInstance().queryCurrentValue("output-file", outputname);
+  ValueStorage::getInstance().queryCurrentValue("bin-output-file", binoutputname);
+  ValueStorage::getInstance().queryCurrentValue("periodic", periodic);
+
+  // execute action
+  output.open(outputname.c_str());
+  binoutput.open(binoutputname.c_str());
+  ASSERT(Boundary != NULL, "No molecule specified for SurfaceCorrelation.");
+  const double radius = 4.;
+  double LCWidth = 20.;
+  if (BinEnd > 0) {
+    if (BinEnd > 2.*radius)
+      LCWidth = BinEnd;
+    else
+      LCWidth = 2.*radius;
+  }
+
+  // get the boundary
+  class Tesselation *TesselStruct = NULL;
+  const LinkedCell *LCList = NULL;
+  // find biggest molecule
+  std::vector<molecule*> molecules = World::getInstance().getSelectedMolecules();
+  std::cout << "There are " << molecules.size() << " selected molecules." << std::endl;
+  LCList = new LinkedCell(Boundary, LCWidth);
+  FindNonConvexBorder(Boundary, TesselStruct, LCList, radius, NULL);
+  CorrelationToSurfaceMap *surfacemap = NULL;
+  if (periodic)
+    surfacemap = PeriodicCorrelationToSurface( molecules, elements, TesselStruct, LCList, ranges);
+  else
+    surfacemap = CorrelationToSurface( molecules, elements, TesselStruct, LCList);
+  delete LCList;
+  OutputCorrelationToSurface(&output, surfacemap);
+  // check whether radius was appropriate
+  {
+    double start; double end;
+    GetMinMax( surfacemap, start, end);
+    if (LCWidth < end)
+      DoeLog(1) && (eLog()<< Verbose(1) << "Linked Cell width is smaller than the found range of values! Bins can only be correct up to: " << radius << "." << endl);
+  }
+  binmap = BinData( surfacemap, BinWidth, BinStart, BinEnd );
+  OutputCorrelation ( &binoutput, binmap );
+  delete TesselStruct;  // surfacemap contains refs to triangles! delete here, not earlier!
+  delete(binmap);
+  delete(surfacemap);
+  output.close();
+  binoutput.close();
+  return Action::success;
+}
+
+Action::state_ptr AnalysisSurfaceCorrelationAction::performUndo(Action::state_ptr _state) {
+  return Action::success;
+}
+
+Action::state_ptr AnalysisSurfaceCorrelationAction::performRedo(Action::state_ptr _state){
+  return Action::success;
+}
+
+bool AnalysisSurfaceCorrelationAction::canUndo() {
+  return true;
+}
+
+bool AnalysisSurfaceCorrelationAction::shouldUndo() {
+  return true;
+}
+
+const string AnalysisSurfaceCorrelationAction::getName() {
+  return NAME;
+}
Index: src/Actions/AnalysisAction/SurfaceCorrelationAction.hpp
===================================================================
--- src/Actions/AnalysisAction/SurfaceCorrelationAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/AnalysisAction/SurfaceCorrelationAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,40 @@
+/*
+ * SurfaceCorrelationAction.hpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#ifndef SURFACECORRELATIONACTION_HPP_
+#define SURFACECORRELATIONACTION_HPP_
+
+#include "Actions/Action.hpp"
+#include <string>
+#include <vector>
+
+class element;
+class molecule;
+
+void AnalysisSurfaceCorrelation(std::vector< element *> &elements, molecule *mol, double BinStart, double BinWidth, double BinEnd, std::string &outputname, std::string &binoutputname, bool periodic);
+
+class AnalysisSurfaceCorrelationAction : public Action {
+  friend void AnalysisSurfaceCorrelation(std::vector< element *> &elements, molecule *mol, double BinStart, double BinWidth, double BinEnd, std::string &outputname, std::string &binoutputname, bool periodic);
+public:
+  AnalysisSurfaceCorrelationAction();
+  virtual ~AnalysisSurfaceCorrelationAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog*);
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* SURFACECORRELATIONACTION_HPP_ */
Index: src/Actions/AtomAction/AddAction.cpp
===================================================================
--- src/Actions/AtomAction/AddAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/AtomAction/AddAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,13 +6,20 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/AtomAction/AddAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Descriptors/AtomIdDescriptor.hpp"
 #include "atom.hpp"
 #include "element.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
-#include "vector.hpp"
-#include "verbose.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -24,5 +31,19 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
+
+// memento to remember the state when undoing
+
+class AtomAddState : public ActionState {
+public:
+  AtomAddState(const Vector &_position, const element *_elemental, const atomId_t _id) :
+    position(_position),
+    elemental(_elemental),
+    id(_id)
+  {}
+  Vector position;
+  const element *elemental;
+  atomId_t id;
+};
 
 const char AtomAddAction::NAME[] = "add-atom";
@@ -35,59 +56,75 @@
 {}
 
+void AtomAdd(element *elemental, Vector &position) {
+  ValueStorage::getInstance().setCurrentValue(AtomAddAction::NAME, elemental);
+  ValueStorage::getInstance().setCurrentValue("position", elemental);
+  ActionRegistry::getInstance().getActionByName(AtomAddAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog * AtomAddAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryElement(NAME, ValueStorage::getInstance().getDescription(NAME));
+  dialog->queryVector("position", true, ValueStorage::getInstance().getDescription("position"));
+
+  return dialog;
+}
+
 Action::state_ptr AtomAddAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
-  std::vector<element *> elements;
+  const element * elemental = NULL;
   Vector position;
 
-  dialog->queryElement(NAME, &elements, MapOfActions::getInstance().getDescription(NAME));
-  dialog->queryVector("position", &position, World::getInstance().getDomain(), true, MapOfActions::getInstance().getDescription("position"));
-  cout << "pre-dialog" << endl;
+  // obtain information
+  ValueStorage::getInstance().queryCurrentValue(NAME, elemental);
+  ValueStorage::getInstance().queryCurrentValue("position", position);
 
-  if(dialog->display()) {
-    cout << "post-dialog" << endl;
-    delete dialog;
-    if (elements.size() == 1) {
-      atom * first = World::getInstance().createAtom();
-      first->type = *(elements.begin());
-      first->x = position;
-      DoLog(1) && (Log() << Verbose(1) << "Adding new atom with element " << first->type->name << " at " << (first->x) << "." << endl);
-      // TODO: remove when all of World's atoms are stored.
-      std::vector<molecule *> molecules = World::getInstance().getAllMolecules();
-      if (!molecules.empty()) {
-        std::vector<molecule *>::iterator iter = molecules.begin();
-        (*iter)->AddAtom(first);
-      }
-      return Action::success;
-    } else {
-      DoeLog(1) && (eLog()<< Verbose(1) << "Could not find the specified element." << endl);
-      return Action::failure;
-    }
-  } else {
-    delete dialog;
-    return Action::failure;
+  // execute action
+  atom * first = World::getInstance().createAtom();
+  first->setType(elemental);
+  first->setPosition(position);
+  DoLog(1) && (Log() << Verbose(1) << "Adding new atom with element " << first->getType()->getName() << " at " << (first->getPosition()) << "." << endl);
+  // TODO: remove when all of World's atoms are stored.
+  std::vector<molecule *> molecules = World::getInstance().getAllMolecules();
+  if (!molecules.empty()) {
+    std::vector<molecule *>::iterator iter = molecules.begin();
+    (*iter)->AddAtom(first);
   }
-
+  return Action::state_ptr(new AtomAddState(position, elemental, first->getId()));
 }
 
 Action::state_ptr AtomAddAction::performUndo(Action::state_ptr _state) {
-//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+  AtomAddState *state = assert_cast<AtomAddState*>(_state.get());
 
-  return Action::failure;
-//  string newName = state->mol->getName();
-//  state->mol->setName(state->lastName);
-//
-//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+  DoLog(1) && (Log() << Verbose(1) << "Removing atom with id " << state->id << "." << endl);
+  World::getInstance().destroyAtom(state->id);
+
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr AtomAddAction::performRedo(Action::state_ptr _state){
-  return Action::failure;
+  AtomAddState *state = assert_cast<AtomAddState*>(_state.get());
+
+  atom * first = World::getInstance().createAtom();
+  first->setType(state->elemental);
+  first->setPosition(state->position);
+  DoLog(1) && (Log() << Verbose(1) << "Re-adding new atom with element " << state->elemental->getName() << " at " << state->position << "." << endl);
+  // TODO: remove when all of World's atoms are stored.
+  std::vector<molecule *> molecules = World::getInstance().getAllMolecules();
+  if (!molecules.empty()) {
+    std::vector<molecule *>::iterator iter = molecules.begin();
+    (*iter)->AddAtom(first);
+  }
+  if (first->getId() != state->id)
+    if (!first->changeId(state->id))
+      return Action::failure;
+  return Action::state_ptr(_state);
 }
 
 bool AtomAddAction::canUndo() {
-  return false;
+  return true;
 }
 
 bool AtomAddAction::shouldUndo() {
-  return false;
+  return true;
 }
 
Index: src/Actions/AtomAction/AddAction.hpp
===================================================================
--- src/Actions/AtomAction/AddAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/AtomAction/AddAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,6 +10,13 @@
 
 #include "Actions/Action.hpp"
+#include "LinearAlgebra/Vector.hpp"
+
+class element;
+
+void AtomAdd(element *elemental, Vector &position);
 
 class AtomAddAction : public Action {
+  friend void AtomAdd(element *elemental, Vector &position);
+
 public:
   AtomAddAction();
@@ -20,4 +27,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/AtomAction/ChangeElementAction.cpp
===================================================================
--- src/Actions/AtomAction/ChangeElementAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/AtomAction/ChangeElementAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,14 +6,24 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/AtomAction/ChangeElementAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Descriptors/AtomIdDescriptor.hpp"
 #include "atom.hpp"
-#include "log.hpp"
-#include "vector.hpp"
-#include "verbose.hpp"
+#include "element.hpp"
+#include "Helpers/Log.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Helpers/Verbose.hpp"
+#include "molecule.hpp"
 #include "World.hpp"
 
 #include <iostream>
+#include <map>
 #include <string>
 
@@ -22,5 +32,19 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
+
+typedef std::map<int, const element *> ElementMap;
+
+// memento to remember the state when undoing
+
+class AtomChangeElementState : public ActionState {
+public:
+  AtomChangeElementState(ElementMap _Elements, const element *_elemental) :
+    Elements(_Elements),
+    elemental(_elemental)
+  {}
+  ElementMap Elements;
+  const element *elemental;
+};
 
 const char AtomChangeElementAction::NAME[] = "change-element";
@@ -33,49 +57,80 @@
 {}
 
+void AtomChangeElement(element *elemental) {
+  ValueStorage::getInstance().setCurrentValue(AtomChangeElementAction::NAME, elemental);
+  ActionRegistry::getInstance().getActionByName(AtomChangeElementAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* AtomChangeElementAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryElement(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+return dialog;
+}
+
 Action::state_ptr AtomChangeElementAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   atom *first = NULL;
-  std::vector<element *> elements;
+  const element *elemental;
+  molecule *mol = NULL;
 
-  dialog->queryElement(NAME, &elements, MapOfActions::getInstance().getDescription(NAME));
-  dialog->queryAtom("atom-by-id", &first, MapOfActions::getInstance().getDescription("atom-by-id"));
+  ValueStorage::getInstance().queryCurrentValue(NAME, elemental);
 
-  if(dialog->display()) {
-    delete dialog;
-    ASSERT(elements.size() == 1, "Unequal to one element specified when changing an atom's element");
-    ASSERT(first != NULL, "No valid atom specified");
-    DoLog(1) && (Log() << Verbose(1) << "Changing atom " << *first << " to element " << elements.at(0) << "." << endl);
-    if (elements.at(0) != NULL) {
-      first->type = elements.at(0);
-      return Action::success;
-    } else
-      return Action::failure;
-  } else {
-    delete dialog;
-    return Action::failure;
+  // create undo state
+  ElementMap Elements;
+  for (World::AtomSelectionIterator iter = World::getInstance().beginAtomSelection(); iter != World::getInstance().endAtomSelection(); ++iter) {
+    Elements.insert(std::pair<int, const element *> (iter->second->getId(), iter->second->getType()));
   }
+  AtomChangeElementState *UndoState = new AtomChangeElementState(Elements, elemental);
 
+  for (World::AtomSelectionIterator iter = World::getInstance().beginAtomSelection(); iter != World::getInstance().endAtomSelection(); ++iter) {
+    first = iter->second;
+    DoLog(1) && (Log() << Verbose(1) << "Changing atom " << *first << " to element " << *elemental << "." << endl);
+    mol = first->getMolecule();
+    first->removeFromMolecule(); // remove atom
+    first->setType(elemental);
+    mol->AddAtom(first);  // add atom to ensure correctness of formula
+  }
+  return Action::state_ptr(UndoState);
 }
 
 Action::state_ptr AtomChangeElementAction::performUndo(Action::state_ptr _state) {
-//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+  AtomChangeElementState *state = assert_cast<AtomChangeElementState*>(_state.get());
+  atom *first = NULL;
+  molecule *mol = NULL;
 
-  return Action::failure;
-//  string newName = state->mol->getName();
-//  state->mol->setName(state->lastName);
-//
-//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+  for(ElementMap::const_iterator iter = state->Elements.begin(); iter != state->Elements.end(); ++iter) {
+    first = World::getInstance().getAtom(AtomById(iter->first));
+    mol = first->getMolecule();
+    first->removeFromMolecule(); // remove atom
+    first->setType(iter->second);
+    mol->AddAtom(first);  // add atom to ensure correctness of formula
+  }
+
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr AtomChangeElementAction::performRedo(Action::state_ptr _state){
-  return Action::failure;
+  AtomChangeElementState *state = assert_cast<AtomChangeElementState*>(_state.get());
+  atom *first = NULL;
+  molecule *mol = NULL;
+
+  for(ElementMap::const_iterator iter = state->Elements.begin(); iter != state->Elements.end(); ++iter) {
+    first = World::getInstance().getAtom(AtomById(iter->first));
+    mol = first->getMolecule();
+    first->removeFromMolecule(); // remove atom
+    first->setType(state->elemental);
+    mol->AddAtom(first);  // add atom to ensure correctness of formula
+  }
+
+  return Action::state_ptr(_state);
 }
 
 bool AtomChangeElementAction::canUndo() {
-  return false;
+  return true;
 }
 
 bool AtomChangeElementAction::shouldUndo() {
-  return false;
+  return true;
 }
 
Index: src/Actions/AtomAction/ChangeElementAction.hpp
===================================================================
--- src/Actions/AtomAction/ChangeElementAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/AtomAction/ChangeElementAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,11 @@
 #include "Actions/Action.hpp"
 
+class element;
+
+void AtomChangeElement(element *elemental);
+
 class AtomChangeElementAction : public Action {
+  friend void AtomChangeElement(element *elemental);
+
 public:
   AtomChangeElementAction();
@@ -20,4 +26,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog*);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/AtomAction/RemoveAction.cpp
===================================================================
--- src/Actions/AtomAction/RemoveAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/AtomAction/RemoveAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,12 +6,19 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/AtomAction/RemoveAction.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "atom.hpp"
+#include "AtomicInfo.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
-#include "verbose.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -23,5 +30,15 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
+
+// memento to remember the state when undoing
+
+class AtomRemoveState : public ActionState {
+public:
+  AtomRemoveState(std::vector<AtomicInfo> _Walkers) :
+    Walkers(_Walkers)
+  {}
+  std::vector<AtomicInfo> Walkers;
+};
 
 const char AtomRemoveAction::NAME[] = "remove-atom";
@@ -34,48 +51,83 @@
 {}
 
+void AtomRemove() {
+  ActionRegistry::getInstance().getActionByName(AtomRemoveAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* AtomRemoveAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr AtomRemoveAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   atom *first = NULL;
 
-  dialog->queryAtom(NAME, &first, MapOfActions::getInstance().getDescription(NAME));
+  // create undo state
+  std::vector<AtomicInfo> Walkers;
+  for (World::AtomSelectionIterator iter = World::getInstance().beginAtomSelection(); iter != World::getInstance().endAtomSelection(); ++iter) {
+    Walkers.push_back(AtomicInfo(*(iter->second)));
+  }
+  AtomRemoveState *UndoState = new AtomRemoveState(Walkers);
 
-  if(dialog->display()) {
-    delete dialog;
+  // remove all selected atoms
+//  std::vector<molecule *> molecules = World::getInstance().getAllMolecules();
+  for (World::AtomSelectionIterator iter = World::getInstance().beginAtomSelection(); iter != World::getInstance().endAtomSelection(); ++iter) {
+    first = iter->second;
     DoLog(1) && (Log() << Verbose(1) << "Removing atom " << first->getId() << "." << endl);
-    // TODO: this is not necessary when atoms and their storing to file are handled by the World
-    // simply try to erase in every molecule found
-    std::vector<molecule *> molecules = World::getInstance().getAllMolecules();
-    for (std::vector<molecule *>::iterator iter = molecules.begin();iter != molecules.end(); ++iter) {
-      (*iter)->erase(first);
-    }
+//    // TODO: this is not necessary when atoms and their storing to file are handled by the World
+//    // simply try to erase in every molecule found
+//    for (std::vector<molecule *>::iterator iter = molecules.begin();iter != molecules.end(); ++iter) {
+//      (*iter)->erase(first);
+//    }
     World::getInstance().destroyAtom(first);
-    return Action::success;
-  } else {
-    delete dialog;
-    return Action::failure;
   }
-
+  return Action::state_ptr(UndoState);
 }
 
 Action::state_ptr AtomRemoveAction::performUndo(Action::state_ptr _state) {
-//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+  AtomRemoveState *state = assert_cast<AtomRemoveState*>(_state.get());
 
-  return Action::failure;
-//  string newName = state->mol->getName();
-//  state->mol->setName(state->lastName);
-//
-//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+  size_t i=0;
+  for (; i<state->Walkers.size(); ++i) {
+    // re-create the atom
+    DoLog(1) && (Log() << Verbose(1) << "Re-adding atom " << state->Walkers[i].getId() << "." << endl);
+    atom *Walker = World::getInstance().createAtom();
+    if (!state->Walkers[i].setAtom(*Walker)) {
+      DoeLog(1) && (eLog() << Verbose(1) << "Failed to set id." << endl);
+      World::getInstance().destroyAtom(Walker);
+      break;
+    }
+  }
+  if (i<state->Walkers.size()) {
+    // remove all previous ones, too
+    for (size_t j=0;j<i;++j)
+      World::getInstance().destroyAtom(state->Walkers[j].getId());
+    // and announce the failure of the undo
+    return Action::failure;
+  }
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr AtomRemoveAction::performRedo(Action::state_ptr _state){
-  return Action::failure;
+  AtomRemoveState *state = assert_cast<AtomRemoveState*>(_state.get());
+
+  // simple remove again all previously added atoms
+  for (size_t i=0; i<state->Walkers.size(); ++i) {
+    DoLog(1) && (Log() << Verbose(1) << "Re-removing atom " << state->Walkers[i].getId() << "." << endl);
+    World::getInstance().destroyAtom(state->Walkers[i].getId());
+  }
+
+  return Action::state_ptr(_state);
 }
 
 bool AtomRemoveAction::canUndo() {
-  return false;
+  return true;
 }
 
 bool AtomRemoveAction::shouldUndo() {
-  return false;
+  return true;
 }
 
